Anonymous | Login
Project:
RSS
  
News | My View | View Issues | Roadmap | Summary

View Issue DetailsJump to Notes ] Issue History ] Print ]
ID
0020591
TypeCategorySeverityReproducibilityDate SubmittedLast Update
defect[Openbravo ERP] Y. DBSourceManagermajorhave not tried2012-05-23 15:192012-05-30 18:13
ReportermarvintmView Statuspublic 
Assigned Tomarvintm 
PriorityurgentResolutionfixedFixed in Version3.0MP12
StatusclosedFix in branchFixed in SCM revision2f1eca1d8609
ProjectionnoneETAnoneTarget Version
OSAnyDatabaseAnyJava version
OS VersionDatabase versionAnt version
Product VersionSCM revision 
Review Assigned To
Web browser
ModulesCore
Regression level
Regression date
Regression introduced in release
Regression introduced by commit
Triggers an Emergency PackNo
Summary

0020591: update.database should not destroy data if a problem happens when recreating a table

DescriptionCurrently, if a problem happens when dbsourcemanager has to recreate a table, the process will delete the original table, and its data will be lost.

This should be clearly avoided.
Steps To Reproduce- Modify a column of a table in the XML, and set it to an illegal value (for example, set the length of a varchar column to a value which is smaller than the data currently in the database).
- Do update.database. Verify that errors appear, but the process continues, and that after it has finished, the table has been deleted, along with its data.
Proposed SolutionThe process should stop in that case, and a message explaining the problem should be shown.
TagsNo tags attached.
Attached Files

- Relationships Relation Graph ] Dependency Graph ]

-  Notes
(0049371)
hgbot (developer)
2012-05-28 15:44

Repository: erp/devel/dbsm-main
Changeset: a6a6f4d9ea32ffea2a7301351660730781cac4c9
Author: Antonio Moreno <antonio.moreno <at> openbravo.com>
Date: Mon May 28 15:44:10 2012 +0200
URL: http://code.openbravo.com/erp/devel/dbsm-main/rev/a6a6f4d9ea32ffea2a7301351660730781cac4c9 [^]

Fixed issue 20591. Fixed issue 20592. Several changes have been made:
- The table creation commands are now considered 'critical'. This means that the process will fail automatically, with an specific message, if one of these commands fails.
- The create fks and triggers methods now return whether there were errors or not during the execution.
- This new boolean is now used by update.database to make the process fail in the end, if some trigger or foreign key was not correctly enabled. This failure is a normal exception which will be detected by the rebuild window as an error in the process.
- Additionally (and unrelated to these issues actually) a new convenient method to load a basic database model which includes only tables has been included.

---
M src/org/apache/ddlutils/Platform.java
M src/org/apache/ddlutils/platform/PlatformImplBase.java
M src/org/apache/ddlutils/platform/SqlBuilder.java
M src/org/apache/ddlutils/platform/oracle/Oracle8Platform.java
M src/org/apache/ddlutils/platform/postgresql/PostgreSqlPlatform.java
M src/org/openbravo/ddlutils/task/AlterDatabaseDataAll.java
M src/org/openbravo/ddlutils/util/DBSMOBUtil.java
---
(0049379)
hgbot (developer)
2012-05-28 17:54

Repository: erp/devel/pi
Changeset: 2f1eca1d8609f493276b969c2733b49463fbc705
Author: Antonio Moreno <antonio.moreno <at> openbravo.com>
Date: Mon May 28 17:31:44 2012 +0200
URL: http://code.openbravo.com/erp/devel/pi/rev/2f1eca1d8609f493276b969c2733b49463fbc705 [^]

Fixed issue 20591. Fixed issue 20592. Several changes have been made:
> - The table creation commands are now considered 'critical'. This means that the process will fail automatically, with an specific message, if one of these commands fails.
> - The create fks and triggers methods now return whether there were errors or not during the execution.
> - This new boolean is now used by update.database to make the process fail in the end, if some trigger or foreign key was not correctly enabled. This failure is a normal exception which will be detected by the rebuild window as an error in the process.
> - Additionally (and unrelated to these issues actually) a new convenient method to load a basic database model which includes only tables has been included.

---
M src-db/database/lib/dbsourcemanager.jar
---
(0049417)
hgbot (developer)
2012-05-29 12:00

Repository: erp/devel/dbsm-main
Changeset: 23f448913ec6acca0df106ac501d3ceb85faedf6
Author: Antonio Moreno <antonio.moreno <at> openbravo.com>
Date: Tue May 29 12:00:20 2012 +0200
URL: http://code.openbravo.com/erp/devel/dbsm-main/rev/23f448913ec6acca0df106ac501d3ceb85faedf6 [^]

Related to issue 20591. Further clarified the message shown when a critical error happens

---
M src/org/apache/ddlutils/platform/PlatformImplBase.java
---
(0049418)
hgbot (developer)
2012-05-29 12:01

Repository: erp/devel/pi
Changeset: 5e3ad075603e5f530868eafeaa71f2076fcaca15
Author: Antonio Moreno <antonio.moreno <at> openbravo.com>
Date: Tue May 29 12:00:37 2012 +0200
URL: http://code.openbravo.com/erp/devel/pi/rev/5e3ad075603e5f530868eafeaa71f2076fcaca15 [^]

Related to issue 20591. Further clarified the message shown when a critical error happens

---
M src-db/database/lib/dbsourcemanager.jar
---
(0049420)
AugustoMauch (developer)
2012-05-29 12:09

Code reviewed and verified in pi@5e3ad075603e
(0049497)
hudsonbot (developer)
2012-05-30 18:13

A changeset related to this issue has been promoted main and to the
Central Repository, after passing a series of tests.

Promotion changeset: https://code.openbravo.com/erp/devel/main/rev/3752a665362c [^]

Maturity status: Test
(0049506)
hudsonbot (developer)
2012-05-30 18:13

A changeset related to this issue has been promoted main and to the
Central Repository, after passing a series of tests.

Promotion changeset: https://code.openbravo.com/erp/devel/main/rev/3752a665362c [^]

Maturity status: Test

- Issue History
Date Modified Username Field Change
2012-05-23 15:19 marvintm New Issue
2012-05-23 15:19 marvintm Assigned To => marvintm
2012-05-23 15:19 marvintm Modules => Core
2012-05-28 15:44 hgbot Checkin
2012-05-28 15:44 hgbot Note Added: 0049371
2012-05-28 15:44 hgbot Status new => resolved
2012-05-28 15:44 hgbot Resolution open => fixed
2012-05-28 15:44 hgbot Fixed in SCM revision => http://code.openbravo.com/erp/devel/dbsm-main/rev/a6a6f4d9ea32ffea2a7301351660730781cac4c9 [^]
2012-05-28 17:54 hgbot Checkin
2012-05-28 17:54 hgbot Note Added: 0049379
2012-05-28 17:54 hgbot Fixed in SCM revision http://code.openbravo.com/erp/devel/dbsm-main/rev/a6a6f4d9ea32ffea2a7301351660730781cac4c9 [^] => http://code.openbravo.com/erp/devel/pi/rev/2f1eca1d8609f493276b969c2733b49463fbc705 [^]
2012-05-29 12:00 hgbot Checkin
2012-05-29 12:00 hgbot Note Added: 0049417
2012-05-29 12:01 hgbot Checkin
2012-05-29 12:01 hgbot Note Added: 0049418
2012-05-29 12:09 AugustoMauch Note Added: 0049420
2012-05-29 12:09 AugustoMauch Status resolved => closed
2012-05-29 12:09 AugustoMauch Fixed in Version => 3.0MP12
2012-05-30 18:13 hudsonbot Checkin
2012-05-30 18:13 hudsonbot Note Added: 0049497
2012-05-30 18:13 hudsonbot Checkin
2012-05-30 18:13 hudsonbot Note Added: 0049506


Copyright © 2000 - 2009 MantisBT Group
Powered by Mantis Bugtracker